<template>
  <div class="branches">
    <div class="columns">
      <div class="column is-2">
        <the-sidebar />
      </div> <!-- column -->
      <div class="column">
        <div class="box">
          <div class="level">
            <div class="level-left">
              <the-header title="Ramais" subtitle="Ramais cadastrados ao sistema" />
            </div> <!-- level-left -->
            <div class="level-right">
              <router-link
                class="button is-primary"
                :to="{name: 'admin-create-branches'}">Novo ramal
              </router-link>
            </div> <!-- level-right -->
          </div>
          <the-admin-table
            :key="adminTableKey"
            :isLoading="isLoading"
            title="Ramais adicionados"
            perPage="20"
            :content="branches"
            :columns="columns"
            v-on:createItem="createItem"
            v-on:readItem="readItem"
            v-on:updateItem="updateItem"
            v-on:deleteItem="deleteItem">
          </the-admin-table>
        </div> <!-- box -->
      </div> <!-- column -->
    </div> <!-- columns -->
  </div>
</template>

<script>
export default {
  name: 'IndexClients',
  data: function ()  {
    return {
      adminTableKey: 0,
    }
  },
  created () {
    this.$store.dispatch('getBranches')
  },
  methods: {
    forceRerender ()  {
      this.adminTableKey += 1
      console.log(this.adminTableKey)
    },
    createItem: function () {
    },
    readItem: function (obj) {
      this.$router.push({ name: 'read-branches', params: { pk: obj.id } })
    },
    updateItem: function (obj) {
      this.$router.push({ name: 'admin-update-branches', params: { pk: obj.id } })
    },
    deleteItem: function (obj) {
      this.$store.dispatch('deleteBranch', obj)
      this.forceRerender()
    }
  },
  computed: {
    branches () {
      return this.$store.state.branches.branches
    },
    columns () {
      return [
        {
          field: 'id',
          label: 'ID',
          numeric: true,
          sortable: true
        },
        {
          field: 'sector',
          label: 'Setor',
          sortable: true
        },
        {
          field: 'contacts',
          label: 'Contato',
          sortable: true
        },
        {
          field: 'branch_line',
          label: 'Ramal',
          sortable: true
        },
        {
          field: 'created_at',
          label: 'Criado em'
        },
        {
          field: 'updated_at',
          label: 'Atualizado em'
        }
      ]

    },
    isLoading () {
      return this.$store.state.branches.loading
    },
    error () {
      return this.$store.state.branches.error
    },
    errorMsg () {
      return this.$store.state.branches.errorMsg
    }
  }
}
</script>
